unit PrimeSearch;

interface

uses
  Classes;

type
  TPrimeSearch = class(TThread)
  private
    { Private 錾 }
    Count: Integer;
    MyBits: TBits;
    procedure PrimeListUpdate;
    procedure PrimeSubListUpdate;
  protected
    procedure Execute; override;
  public
    BasePrimeHigh, RangeLow, RangeHigh: Cardinal;
    Index: Integer;
    SynchronizeFlag: Boolean;
  end;

implementation
uses frmMain, Dialogs, SysUtils;

procedure TPrimeSearch.Execute;
var
  c, d, e: Cardinal;
  i: Integer;
begin
  MyBits := TBits.Create;
  try
    MyBits.Size := RangeHigh - RangeLow + 1;

    for c := 0 to BasePrimeHigh do
    begin
      e := FormMain.PrimeArray[c];
      if e > Trunc(Sqrt(RangeHigh)) then Break;
      for d := (RangeLow div e) to (RangeHigh div e) do
      begin
        i := e * d - RangeLow;
        if i >= 0 then MyBits[i] := True;
      end;
    end;

    Count := 0;
    for c := 0 to MyBits.Size - 1 do
      if Not MyBits[c] then Inc(Count);

    if FormMain.ThreadMax < 1 then
      PrimeListUpdate
    else
      PrimeSubListUpdate;
  finally
    MyBits.Free;
  end;
end;

procedure TPrimeSearch.PrimeListUpdate;
var
  c: Cardinal;
  i, OldHigh: Integer;
begin
  OldHigh := High(FormMain.PrimeArray);
  SetLength(FormMain.PrimeArray, OldHigh + 1 + Count);

  i := 1;
  for c := 0 to MyBits.Size - 1 do
  begin
    if Not MyBits[c] then
    begin
      FormMain.PrimeArray[OldHigh + i] := RangeLow + c;
      Inc(i);
    end;
  end;
end;

procedure TPrimeSearch.PrimeSubListUpdate;
var
  c: Cardinal;
  i: Integer;
begin
  SetLength(FormMain.PrimeArrayWriteBuffer[Index], Count);

  i := 0;
  for c := 0 to MyBits.Size - 1 do
  begin
    if Not MyBits[c] then
    begin
      FormMain.PrimeArrayWriteBuffer[Index][i] := RangeLow + c;
      Inc(i);
    end;
  end;
end;

end.
