unit frmGather;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, ComCtrls, ShellCtrls;

type
  TFormGather = class(TForm)
    PanelRight: TPanel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ShellTreeViewMain: TShellTreeView;
    procedure FormCreate(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormGather: TFormGather;

implementation

{$R *.dfm}
uses frmMain, StrUtils, IniFiles;

procedure TFormGather.FormCreate(Sender: TObject);
var
  s: string;
  Ini: TIniFile;
begin
  PanelRight.Align := alRight;
  PanelRight.Caption := '';
  ShellTreeViewMain.Align := alClient;

  s := (ChangeFileExt(Application.ExeName, '.ini'));
  Ini := TIniFile.Create(s);
  with Ini do
  begin
    Self.Top := ReadInteger('Gather', 'Top', FormMain.Top + 50);
    Self.Left := ReadInteger('Gather', 'Left', FormMain.Left + 50);
    Self.Width := ReadInteger('Gather', 'Width', FormMain.Width div 3 * 2);
    Self.Height := ReadInteger('Gather', 'Height', FormMain.Height div 2);
    Free;
  end;
end;

procedure TFormGather.ButtonCancelClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TFormGather.ButtonOKClick(Sender: TObject);
const
  FILE_MAX = 21;
  FILENAME_LIST: array[0..FILE_MAX] of string = (
    '2k', '4k', '8k', '16k', '32k',
    '64k', '128k', '256k', '512k', '1024k',
    '2048k', '4096k', '8192k', '16384k', '32768k',
    '65536k', '131072k', '262144k', '524288k', '1048576k',
    '2097152k', '4194304k');
  FILE_EXTENSION = '.txt';
var
  Count: Integer;
  Found: array[0..FILE_MAX] of Boolean;
  i, j, k, l: Integer;
  s, t: string;
  sl1, sl2, sl3: TStringList;
begin
  s := ShellTreeViewMain.Path;
  if RightStr(s, 1) <> '\' then s := s + '\';

  Count := 0;
  for i := 0 to FILE_MAX do
  begin
    Found[i] := False; //ȂƊȂ
    if FileExists(s + FILENAME_LIST[i] + FILE_EXTENSION) then
    begin
      Found[i] := True;
      Inc(Count);
    end;
  end;

  if Count > 0 then
  begin
    sl1 := TStringList.Create;
    sl2 := TStringList.Create;
    sl3 := TStringList.Create;

    t := 'qXbh' + #09;
    for i := 0 to FILE_MAX do
      if Found[i] then t := t + FILENAME_LIST[i] + #09;

    for k := 0 to 1 do
    begin
      sl3.Add(t);
      for i := 0 to THREAD_MAX + 1 do
        sl3.Add(IntToStr(i) + #09);

      for i := 0 to FILE_MAX do
      begin
        if Found[i] then
        begin
          sl1.LoadFromFile(s + FILENAME_LIST[i] + FILE_EXTENSION);
          j := 11;
          while j < sl1.Count - 1 do
          begin
            if LeftStr(sl1[j], 1) = '-' then
            begin
              Break;
            end else begin
              sl2.Delimiter := #09;
              sl2.DelimitedText := sl1[j];

              l := j - 10 + k * 67;
              case k of
                0: sl3[l] := sl3[l] + sl2[3] + #09;
                1: sl3[l] := sl3[l] + sl2[2] + #09;
              end;
              Inc(j);
            end;
          end;
        end;
      end;
      sl3.Add('');
    end;
    s := s + 'Result' + FILE_EXTENSION;
    sl3.SaveToFile(s);
    ShowMessage('Wvʂ' + s + 'ɏo͂܂');
    sl1.Free;
    sl2.Free;
    sl3.Free;
    
    Self.Close;
  end else begin
    ShowMessage('t@Ct܂');
  end;
end;

procedure TFormGather.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Ini: TIniFile;
  s: string;
begin
  s := (ChangeFileExt(Application.ExeName, '.ini'));
  try
    Ini := TIniFile.Create(s);
    With Ini do
    begin
      WriteInteger('Gather', 'Top', Self.Top);
      WriteInteger('Gather', 'Left', Self.Left);
      WriteInteger('Gather', 'Width', Self.Width);
      WriteInteger('Gather', 'Height', Self.Height);
      UpdateFile; //Windowsł͂ȂĂ
      Free;
    end;
  except
    //Ini.Free;
  end;
end;

end.
