unit hhUnit01;

interface
uses Dialogs, Windows, SysUtils, ShlObj, ActiveX, ComObj;
type
  EhhGetComputerName = class(Exception) end;
  EhhGetUserName = class(Exception) end;
  EhhMakeShortcut = class(Exception) end;

function hhGetComputerName: string;
function hhGetGUID: string;
function hhGetUserName: string;
procedure hhMakeShortcut(Path, Target, Description: string);

implementation

//[U[𓾂֐
function hhGetUserName: string;
const
  UNLEN = 257;
var
  s: string;
  Size: DWORD;
  r: BOOL;
begin
  Size := UNLEN;
  SetLength(s, Size);

  r := GetUserName(PChar(s), Size);
  if r <> True then
    raise EhhGetUserName.CreateFmt
      ('%s', ['Failed to call GetUserName'])
  else
    Result := PChar(s);
end;

function hhGetGUID: string;
var
  g: TGUID;
  s: string;
begin
  CoCreateGUID(g);
  s := GUIDToString(g);
  Result := s;
end;


//Rs[^擾֐
function hhGetComputerName: string;
var
  s: string;
  Size: DWORD;
  r: BOOL;
begin
  Size := MAX_COMPUTERNAME_LENGTH + 1;
  SetLength(s, Size);
  r := GetComputerName(PChar(s), Size);
  if r <> True then
    raise EhhGetComputerName.CreateFmt
      ('%s', ['Failed to call GetComputerName'])
  else
    Result := PChar(s);

end;

//V[gJbg쐬
procedure hhMakeShortcut(Path, Target, Description: string);
var
  CO: IUnknown;
  SL: IShellLink;
  PF: IPersistFile;
  r: HRESULT;
  WFilename: WideString;
begin
  CO := CreateComObject(CLSID_ShellLink);
  SL := CO as IShellLink;
  PF := CO as IPersistFile;
  With SL do
  begin
    SetPath(PChar(Target));
    SetWorkingDirectory(PChar(ExtractFilePath(Target)));
    SetDescription(PChar(Description));
  end;
  WFilename := Path;
  r := PF.Save(PWChar(WFilename), False);
  if r <> S_OK then
    raise EhhGetUsername.CreateFmt
      ('%s', ['Failed to call IPersistFile.Save'])
end;

end.
