unit hhUnitWindowsVersion;

interface
uses Windows, Classes, SysUtils;
type
  //EhhWindowsVersionƂO\邽߂ɃNX`
  EhhWindowsVersion = class(Exception)
  end;
  
  //Windows̃o[W𓾂邽߂̃NX
  ThhWindowsVersion = class(TObject)
  private
    InternalIsNT: Boolean;
    InternalText: string;
    OSVersionInfo: TOSVersionInfo;
  public
    constructor Create(AOwner: TComponent);
    property IsNT: Boolean read InternalIsNT;
    property Text: string read InternalText;
  end;

implementation

constructor ThhWindowsVersion.Create(AOwner: TComponent);
var
  r: BOOL;
  s: string;
begin
  OsVersionInfo.dwOSVersionInfoSize :=
    SizeOf(OSVersionInfo);
  r := GetVersionEx(OsVersionInfo);
  if r <> True then
    raise EhhWindowsVersion.CreateFmt
      ('%s', ['Failed to call GetVersionEx'])
  else
  begin
    InternalIsNT := False;
    with OSVersionInfo do
    begin
      case dwPlatformId of
        VER_PLATFORM_WIN32s:
          s := 'Windows 3.1(Win32s)';
        VER_PLATFORM_WIN32_WINDOWS:
          s := 'Windows 95 series';
        VER_PLATFORM_WIN32_NT:
          begin
            s := 'Windows NT series';
            InternalIsNT := True;
          end;
      end;
      s := s + ' Version ' + IntToStr(dwMajorVersion);
      s := s + '.' + IntToStr(dwMinorVersion);
      s := s + ' Build ' + IntToStr(dwBuildNumber);
      s := s + ' ' + szCSDVersion;
      InternalText := s;
    end;
  end;
end;
end.
